import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import classNames from 'classnames';
import { ElementButton } from './ElementButton';
import { ElementCodeBlock } from './ElementCodeBlock';
import { ElementIcon } from './ElementIcon';
import { ElementTextInput } from './ElementTextInput';
export function ElementInput(props) {
    const { element, context, state } = props;
    const { label, element: childElement } = element;
    return (_jsxs("div", { className: classNames('contentkit-form'), children: [label ? _jsx("label", { className: "contentkit-label", children: label }) : null, getInputElement({ element: childElement, context, state })] }));
}
function getInputElement(props) {
    const { element, context, state } = props;
    //!!TODO add support for:
    // - select
    // - switch
    // - radio
    // - checkbox
    switch (element.type) {
        case 'textinput':
            return _jsx(ElementTextInput, { element: element });
        case 'button':
            return (_jsx(ElementButton, { element: element, icon: element.icon ? _jsx(ElementIcon, { icon: element.icon, context: context }) : null, trailingIcon: element.trailingIcon ? (_jsx(ElementIcon, { icon: element.trailingIcon, context: context })) : null }));
        case 'codeblock':
            return _jsx(ElementCodeBlock, { element: element, context: context, state: state });
    }
}
